//mygraph.cpp
#include <windows.h>
#include <math.h>
#include <float.h>
#include "mygraph.h"
VOID Plot8(HDC hdc,int xc,int yc,int x,int y)
{
	COLORREF col=0x00000000;
	SetPixel(hdc,xc+x,yc+y,col);
	SetPixel(hdc,xc-x,yc+y,col);
	SetPixel(hdc,xc+x,yc-y,col);
	SetPixel(hdc,xc-x,yc-y,col);
	SetPixel(hdc,xc+y,yc+x,col);
	SetPixel(hdc,xc-y,yc+x,col);
	SetPixel(hdc,xc+y,yc-x,col);
	SetPixel(hdc,xc-y,yc-x,col);
}
VOID _fastcall MyCircle(HDC hdc,int xc,int yc,int r)
{
	int register x=0;
	int register y=r;
	int register F=1-r;
	int register dFs=3;
	int register dFd=5-2*r;
	while (x<=y)
	{
		Plot8(hdc,xc,yc,x,y);
		if (F>=0)
		{
			F+=dFd;
			x++;
			y--;
			dFs+=2;
			dFd+=4;
		}
		else
		{
			F+=dFs;
			x++;
			dFs+=2;
			dFd+=2;
		}
	}
}

int inline round(float f)
{
	return int(f+_copysign(0.5,f));
}
VOID _fastcall MySegment(HDC hdc, int xc, int yc, int r,float a1, float a2,COLORREF color)
{
	int register x=0;
	int register y=r;
	int register F=1-r;
	int register dFs=3;
	int register dFd=5-2*r;
	static float
		p1=0.78539816339744830961566084581988f,
		p2=1.5707963267948966192313216916398f,
		p3=2.3561944901923449288469825374596f,
		p4=3.1415926535897932384626433832795f,
		p5=3.9269908169872415480783042290994f,
		p6=4.7123889803846898576939650749193f,
		p7=5.4977871437821381673096259207391f,
		p8=6.283185307179586476925286766559f;

	int xs,xe,ys,ye;
	if (((a1>p1)&&(a1<p3)) || ((a1>p5)&&(a1<p7)))
	{
		ys=-round(cos(a1)*r);
		xs=-round(sqrt(r*r-ys*ys));
		if (a1>p4) xs=-xs;
	}
	else
	{
		xs=round(sin(a1)*r);
		ys=-round(sqrt(r*r-xs*xs));
		if ((a1>p2)&&(a1<p6)) ys=-ys;
	}
	if (((a2>p1)&&(a2<p3)) || ((a2>p5)&&(a2<p7)))
	{
		ye=-round(cos(a2)*r);
		xe=-round(sqrt(r*r-ye*ye));
		if (a2>p4) xe=-xe;
	}
	else
	{
		xe=round(sin(a2)*r);
		ye=-round(sqrt(r*r-xe*xe));
		if ((a2>p2)&&(a2<p6)) ye=-ye;
	}


	//MoveToEx(hdc,xc,yc,NULL);
	//LineTo(hdc,xc+xs,yc-round(cosf(a1)*r));

	//MoveToEx(hdc,xc,yc,NULL);
	//LineTo(hdc,xc+xe,yc-round(cosf(a2)*r));

	LineBres(hdc,xs+xc,ys+yc,xc,yc,color);
	LineBres(hdc,xe+xc,ye+yc,xc,yc,color);

	xs=abs(xs);
	ys=abs(ys);
	xe=abs(xe);
	ye=abs(ye);

	BOOL *ss,*es;
	BOOL s[9]={TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE};
		

	float fa1,fa2;
	if (a1<a2)
	{
		fa1=a1; fa2=a2;
	}
	else
	{
		fa1=a2; fa2=a1;
	}

	int n=0;
	n=int
		(fa1/p1)+1;
	for (int m=1; m<n;m++)
		s[m]=FALSE;

	s[n]=!(n%2);
	ss=&(s[n]);

	n=int(fa2/p1)+1;
	for (m=8; m>n;m--)
		s[m]=FALSE;

	s[n]=(n%2);
	es=&(s[n]);

	if (a1>a2)
	
		for (n=1; n<=8; n++) s[n]=!(s[n]);
	
	
	while (x<=y)
	{
		if (  ((x==xs)&&(y==ys))||((x==ys)&&(y==xs))  )
		{
			if (*ss) (*ss)=FALSE;
				else (*ss)=TRUE;
		}
		if (  ((x==xe)&&(y==ye))||((x==ye)&&(y==xe))  )
		{
			if (*es) (*es)=FALSE;
				else (*es)=TRUE;
		}
		if (s[4]) SetPixel(hdc,xc+x,yc+y,color);
		if (s[5]) SetPixel(hdc,xc-x,yc+y,color);
		if (s[1]) SetPixel(hdc,xc+x,yc-y,color);
		if (s[8]) SetPixel(hdc,xc-x,yc-y,color);
		if (s[3]) SetPixel(hdc,xc+y,yc+x,color);
		if (s[6]) SetPixel(hdc,xc-y,yc+x,color);
		if (s[2]) SetPixel(hdc,xc+y,yc-x,color);
		if (s[7]) SetPixel(hdc,xc-y,yc-x,color);
		if (F>=0)
		{
			F+=dFd;
			x++;
			y--;
			dFs+=2;
			dFd+=4;
		}
		else
		{
			F+=dFs;
			x++;
			dFs+=2;
			dFd+=2;
		}
	}

}



VOID LineBres(HDC hdc,int x0,int y0, int xEnd, int yEnd,COLORREF color)
{
	int register dx=fabs(xEnd-x0),dy=fabs(yEnd-y0);

	int register x, y;
	int register mdy,mdx;
	if (yEnd>y0) mdy=1; else mdy=-1;
	if (xEnd>x0) mdx=1; else mdx=-1;

	if (dx>dy)
	{
		int p=2*dy-dx;
		int twoDy=2*dy, twoDyMinusDx=2*(dy-dx);
		if  (x0>xEnd)
		{
			x=xEnd;
			y=yEnd;
			xEnd=x0;
			yEnd=y0;
			mdy=-mdy;
		}
		else
		{
		
			x=x0;
			y=y0;
			mdy=mdy;
		}
		SetPixel(hdc,x,y,color);
		while (x!=xEnd)
		{
			x++;
			if (p<0)
				p+=twoDy;
				else
				{
					y+=mdy;
					p+=twoDyMinusDx;
				}
				SetPixel(hdc,x,y,color);
		
		}
	}
	else
	{
		int p=2*dx-dy;
		int twoDy=2*dx, twoDyMinusDx=2*(dx-dy);
		if  (y0>yEnd)
		{
			x=xEnd;
			y=yEnd;
			xEnd=x0;
			yEnd=y0;
			mdx=-mdx;
		}
		else
		{
		
			x=x0;
			y=y0;
			mdx=mdx;
		}
		SetPixel(hdc,x,y,color);
		while (y!=yEnd)
		{
			y++;
			if (p<0)
				p+=twoDy;
				else
				{
					x+=mdx;
					p+=twoDyMinusDx;
				}
				SetPixel(hdc,x,y,color);
		
		}
	}


}